/*********************************************************************
 *
 *     Fichero utilizado para las comunicaciones UDP. Configuracin
 *		de MAC, IPAddress, etc. Inicializacin del protocolo como recepcin
 *		y envio de mensajes UDP.
 *
 *********************************************************************
 * FileName:        Trama_Ethernet.c
 *
 * Author  Alejandro Daniel Pez Espinosa     Date 18/07/2012
 ********************************************************************/
#include "TramaEthernet.h"
 
UDP_SOCKET  servidor;
 
 // Funcin requerida para el funcionamiento de las funciones de red
void EthernetInit()
{
	MACAddrInit();
   	//IPAddrInit();
   	StackInit();
  	ClienteUDPInit(); 	
}  	

// Funcin que establece la direccin MAC
void MACAddrInit()
{
	MY_MAC_BYTE1=0x00;
	MY_MAC_BYTE2=0x04;
	MY_MAC_BYTE3=0xA3;
	MY_MAC_BYTE4=0x00;
	MY_MAC_BYTE5=0x00;
	MY_MAC_BYTE6=0x01;
}

// Funcin de configuracin de la tarjeta de red
void IPAddrInit()
{
	//Direccion IP por Defecto
	MY_IP_BYTE1=192;
	MY_IP_BYTE2=168;
	MY_IP_BYTE3=2;
	MY_IP_BYTE4=254;
	
	//Puerta de Enlace por Defecto
	MY_GATE_BYTE1=192;
	MY_GATE_BYTE2=168;
	MY_GATE_BYTE3=2;
	MY_GATE_BYTE4=1;
	
	//Mascara de Subred por Defecto
	MY_MASK_BYTE1=255;
	MY_MASK_BYTE2=255;
	MY_MASK_BYTE3=255;
	MY_MASK_BYTE4=0;
}

// Inicia el servicio UDP
void ClienteUDPInit()
{
    
    // Si queires que sea un cliente en NULL hay que establecer los datos del servidor
    // Pero es mejor utilizar el servidor en el PIC
    servidor = UDPOpen(PUERTO_LOCAL, NULL, PUERTO_REMOTO);
    if(servidor == INVALID_UDP_SOCKET)
    {
        ON(PIN_J5);
    }
    else
    {
        ON(PIN_J6);
    }
}

// Funcion de envio de paquetes UDP
void EnviarMensajeUDP(char * buffer)
{
    int8 i;    
	if(UDPIsPutReady(servidor))
	{
		for(i=0;i<LONG_TRAMA;i++)
		{ 
			UDPPut(buffer[i]);
		}
		UDPFlush();
	}	
}

// Funcion de recepcin de paquetes UDP
void RecibirMensajeUDP()
{
    int i=0;
	
	if(UDPIsGetReady(servidor)){
		disable_interrupts(INT_TIMER0);
		UDPGet(&rx_trama[i]);
		i++;
		while( i<LONG_TRAMA-2)
		{		    
			UDPGet(&rx_trama[i]);    	
			i++;	
		}	    		
		recibo=TRUE;
		enable_listen=FALSE;
		enable_interrupts(INT_TIMER0);
	}
}   
    
