#ifndef __TRAMAETHERNET_H
#define __TRAMAETHERNET_H

/*********** Definiciones para RED ***********/

#define     PUERTO_LOCAL    16000
#define     PUERTO_REMOTO   15000

/********** Definiciones para ENC28J60 ********/

/***********************************************
 *
 *     	Pin 	Descripcin
 *
 *		CSK 	Entrada de reloj SPI interface
 *		RST 	Pin de Reset a nivel bajo
 *		CS 		Seleccin del chip mediante SPI
 *		MOSI 	Pin de entrada de datos SPI
 *		MISO 	Pin de salida de datos SPI
 *		WOL 	No conectado
 *		INT 	Pin de interrupcin
 *		CLKO 	Reloj de salida programable
 *
 **********************************************/

#define  PIN_ENC_MAC_SO    PIN_C4   // Conectar con PIN MISO del ENC28J60.
#define  PIN_ENC_MAC_SI    PIN_C5   // Conectar con PIN MOSI del ENC28J60. 
#define  PIN_ENC_MAC_CLK   PIN_C3   // Conectar con PIN SCK del ENC28J60. 
#define  PIN_ENC_MAC_CS    PIN_D3	// Conectar con PIN CS del ENC28J60. 
#define  PIN_ENC_MAC_RST   PIN_D2   // Conectar con PIN RST del ENC28J60. 
#define  PIN_ENC_MAC_INT   PIN_D0   // Conectar con PIN INT del ENC28J60. 
#define  PIN_ENC_MAC_WOL   PIN_D4   // Conectar con PIN WOL del ENC28J60. 

/************* Protocolos a Utilizar **********/

#define  STACK_USE_MCPENC  		TRUE
#define  STACK_USE_ARP     		TRUE
#define  STACK_USE_ICMP    		TRUE
#define  STACK_USE_UDP     		TRUE

#include "tcpip/stacktsk.c"

void EthernetInit();
void MACAddrInit();
void IPAddrInit();
void ClienteUDPInit();
void EnviarMensajeUDP(char * buffer);
void RecibirMensajeUDP();

#endif
